package llvm

var (
	// Basic types.
	Pointer  = &TypePointer  { } // ptr
	Void     = &TypeVoid     { } // void
	MMX      = &TypeMMX      { } // x86_mmx
	Label    = &TypeLabel    { } // label
	Token    = &TypeToken    { } // token
	Metadata = &TypeMetadata { } // metadata
	// Integer types.
	I1    = &TypeInt { BitSize: 1 }    // i1
	I2    = &TypeInt { BitSize: 2 }    // i2
	I3    = &TypeInt { BitSize: 3 }    // i3
	I4    = &TypeInt { BitSize: 4 }    // i4
	I5    = &TypeInt { BitSize: 5 }    // i5
	I6    = &TypeInt { BitSize: 6 }    // i6
	I7    = &TypeInt { BitSize: 7 }    // i7
	I8    = &TypeInt { BitSize: 8 }    // i8
	I16   = &TypeInt { BitSize: 16 }   // i16
	I32   = &TypeInt { BitSize: 32 }   // i32
	I64   = &TypeInt { BitSize: 64 }   // i64
	I128  = &TypeInt { BitSize: 128 }  // i128
	I256  = &TypeInt { BitSize: 256 }  // i256
	I512  = &TypeInt { BitSize: 512 }  // i512
	I1024 = &TypeInt { BitSize: 1024 } // i1024
	// Floating-point types.
	Half      = &TypeFloat { Kind: FloatKindHalf }      // half
	Float     = &TypeFloat { Kind: FloatKindFloat }     // float
	Double    = &TypeFloat { Kind: FloatKindDouble }    // double
	X86_FP80  = &TypeFloat { Kind: FloatKindX86_FP80 }  // x86_fp80
	FP128     = &TypeFloat { Kind: FloatKindFP128 }     // fp128
	PPC_FP128 = &TypeFloat { Kind: FloatKindPPC_FP128 } // ppc_fp128
	// Pointer type.
)
